import {world, system} from "@minecraft/server";
import * as project    from "./project/index.js";
import {join}          from "./utility/join.js";
import {snap_yaw}      from "./utility/snap.yaw.js";
import {spawn_in_air}  from "./utility/spawn_in_air.js";

world.beforeEvents.worldInitialize.subscribe(({blockComponentRegistry: block, itemComponentRegistry: item}) => {
	block.registerCustomComponent("tms_mlb:display.jersey" , project.display_jersey.permutate );
	block.registerCustomComponent("tms_mlb:fridge.mini"    , project.fridge_mini.interact     );
	block.registerCustomComponent("tms_mlb:lava_lamp"      , project.lava_lamp.interact       );
	block.registerCustomComponent("tms_mlb:popcorn_machine", project.popcorn_machine.interact );
	block.registerCustomComponent("tms_mlb:seat"           , project.seat.interact            );
	block.registerCustomComponent("tms_mlb:seat.couch"     , project.seat.couch               );
	block.registerCustomComponent("tms_mlb:table.dining"   , project.table_dining.permutate   );
	 item.registerCustomComponent("tms_mlb:team_selector"  , project.team_selector.open       );
	 item.registerCustomComponent("tms_mlb:spawn_in_air"   , spawn_in_air                     );
});

system.afterEvents.scriptEventReceive.subscribe((event) => {
	switch (event.id) {
		case "tms_mlb:seat.stadium.enter" : project.seat.stadium_enter(event.sourceEntity); break;
		case "tms_mlb:seat.stadium.exit"  : project.seat.stadium_exit(event.sourceEntity); break;
		case "tms_mlb:snap.yaw"           : snap_yaw(event.sourceEntity, Number(event.message)); break;
		case "tms_mlb:scoreboard.interact": project.scoreboard.interact(event.sourceEntity, Number(event.message)); break;
		default: break;
	};
});

world.afterEvents.entityHitEntity.subscribe(({damagingEntity, hitEntity}) => {
	if (
		damagingEntity.typeId === "minecraft:player" &&
		hitEntity.typeId === "tms_mlb:scoreboard"
	) project.scoreboard.form_main(damagingEntity, hitEntity);
});

world.afterEvents.playerSpawn.subscribe(({player, initialSpawn}) => {
	if (!initialSpawn) return;
	if (player.hasTag("tms_mlb:joined")) return;
	join(player);
});