import {system, ItemStack, BlockPermutation} from "@minecraft/server";
import * as inventory                        from "../utility/inventory.js";

let close_timeout_id = null;

const interact = {onPlayerInteract({block, block: {permutation: states}, face, player}) {
	
	if (player.isSneaking) return;

	const direction = states.getState("minecraft:cardinal_direction");

	if (face.toLowerCase() !== direction) return;

	const new_item = new ItemStack("tms_mlb:creepa_cola", 1);
	inventory.give(player, new_item);

	if (close_timeout_id != null) system.clearRun(close_timeout_id);
	
	close_timeout_id = system.runTimeout(() => {
		close_timeout_id = null;

		if (block.typeId !== "tms_mlb:fridge.mini") return; // COMMENT: needed to prevent block from placing if broken before timeout is reached

		block.dimension.playSound("tms_mlb:fridge.mini.close", block.location);
		const new_states = BlockPermutation.resolve("tms_mlb:fridge.mini", {
			"tms_mlb:open": false,
			"minecraft:cardinal_direction": direction
		});
		block.setPermutation(new_states);
	}, 20);
	
	if (states.getState("tms_mlb:open")) return;

	block.dimension.playSound("tms_mlb:fridge.mini.open", block.location);
	const new_states = BlockPermutation.resolve("tms_mlb:fridge.mini", {
		"tms_mlb:open": true,
		"minecraft:cardinal_direction": direction
	});
	block.setPermutation(new_states);
}};

export {
	interact
};