import {BlockPermutation} from "@minecraft/server";

const interact = {onPlayerInteract({player, block, face}) {
	const item = player.getComponent("equippable")?.getEquipment("Mainhand")?.typeId || "";
	const type = item.endsWith("dye");
	
	if (!type) return;

	const namespace = item.startsWith("minecraft:");

	if (!namespace) return;
	
	const dye = item.slice(10, -4);

	face === "Up" ? lava_color(dye, block) : base_color(dye, block);
}};

function base_color(dye, block) {
	const lava = block.permutation.getState("tms_mlb:lava");
	
	switch (dye) {
		case "white"     : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "light_gray": {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "gray"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "black"     : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "brown"     : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "red"       : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "orange"    : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "yellow"    : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "lime"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "green"     : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "cyan"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "light_blue": {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "blue"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "purple"    : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "magenta"   : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		case "pink"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": dye, "tms_mlb:lava": lava}); block.setPermutation(new_states); break;};
		default          : break;
	};
}

function lava_color(dye, block) {
	const base = block.permutation.getState("tms_mlb:base");
	
	switch (dye) {
		case "white"     : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "light_gray": {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "gray"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "black"     : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "brown"     : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "red"       : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "orange"    : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "yellow"    : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "lime"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "green"     : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "cyan"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "light_blue": {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "blue"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "purple"    : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "magenta"   : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		case "pink"      : {const new_states = BlockPermutation.resolve("tms_mlb:lava_lamp", {"tms_mlb:base": base, "tms_mlb:lava": dye}); block.setPermutation(new_states); break;};
		default          : break;
	};
}

export {
	interact
};