import {ActionFormData} from "@minecraft/server-ui";

function interact(button, step) {
	const display = button.getComponent("minecraft:riding").entityRidingOn;
	const type    = "tms_mlb:"+button.getProperty("tms_mlb:button");

	const values = {
		"tms_mlb:home"   : {value: display.getProperty("tms_mlb:home"   ), min: 0, max: 99},
		"tms_mlb:away"   : {value: display.getProperty("tms_mlb:away"   ), min: 0, max: 99},
		"tms_mlb:inning" : {value: display.getProperty("tms_mlb:inning" ), min: 0, max: 17},
		"tms_mlb:balls"  : {value: display.getProperty("tms_mlb:balls"  ), min: 0, max:  3},
		"tms_mlb:strikes": {value: display.getProperty("tms_mlb:strikes"), min: 0, max:  2},
		"tms_mlb:outs"   : {value: display.getProperty("tms_mlb:outs"   ), min: 0, max:  2} 
	};

	values[type].value = values[type].value + step;

	const pitch = () => {
		values["tms_mlb:balls"].value = 0;
		values["tms_mlb:strikes"].value = 0;
	};

	if (type === "tms_mlb:outs"                )  pitch();
	if (type === "tms_mlb:inning"              ) {pitch(); values["tms_mlb:outs"].value = 0;}
	if (values[  "tms_mlb:balls"  ].value === 4)  pitch();
	if (values[  "tms_mlb:strikes"].value === 3) {pitch(); values["tms_mlb:outs"].value++  ;}
	if (values[  "tms_mlb:outs"   ].value === 3) {pitch(); values["tms_mlb:outs"].value = 0; values["tms_mlb:inning"].value++;}

	const wrap = (value, min, max) => ((value - min) % (max - min + 1) + (max - min + 1)) % (max - min + 1) + min;

	Object.entries(values).forEach(([key, {value, min, max}]) => {display.setProperty(key, wrap(value, min, max));});
}

function form_main(player, button) {
	const display = button.getComponent("minecraft:riding").entityRidingOn;

	const form = new ActionFormData().title("tms_mlb:form.scoreboard.main.title");
	form.button("tms_mlb:form.scoreboard.main.how_to");
	form.button("tms_mlb:form.scoreboard.main.reset");
	form.button("tms_mlb:form.scoreboard.main.despawn");

	form.show(player).then(({canceled, selection}) => {
		if (canceled       ) return;
		if (selection === 0) form_how(player, button);
		if (selection === 1) display.triggerEvent("tms_mlb:reset.game");
		if (selection === 2) display.triggerEvent("tms_mlb:despawn.return");
	});
}

function form_how(player, button) {
	const form = new ActionFormData().title("tms_mlb:form.scoreboard.how_to.title");
	form.body({translate: "tms_mlb:form.scoreboard.how_to.body", with: ["\n"]});
	form.button("tms_mlb:form.scoreboard.how_to.back");

	form.show(player).then(({canceled, selection}) => {
		if (canceled       ) return;
		if (selection === 0) form_main(player, button);
	});
}

export {
	interact,
	form_main
};