import {ItemStack}      from "@minecraft/server";
import {ActionFormData} from "@minecraft/server-ui";
import * as inventory   from "../utility/inventory.js";

const teams = [
	"angels",
	"astros",
	"athletics",
	"blue_jays",
	"braves",
	"brewers",
	"cardinals",
	"cubs",
	"diamondbacks",
	"dodgers",
	"giants",
	"guardians",
	"mariners",
	"marlins",
	"mets",
	"nationals",
	"orioles",
	"padres",
	"phillies",
	"pirates",
	"rangers",
	"rays",
	"red_sox",
	"reds",
	"rockies",
	"royals",
	"tigers",
	"twins",
	"white_sox",
	"yankees"
];

const open = {onUse({source: player, itemStack: item, itemStack: {typeId: item_id}}) {
	const item_id_prefix = item_id.slice(0, item_id.lastIndexOf("."));
	const form_id_prefix = "tms_mlb:form.team_selector";
	const icon_directory = "textures/tms/mlb/logo";
	const form           = new ActionFormData().title(`${form_id_prefix}.title`);

	teams.forEach(team => {
		form.button(`${form_id_prefix}.${team}`, `${icon_directory}/${team}`);
	});

	form.show(player).then((result) => {
		if (result.canceled) return;

		const new_item  = new ItemStack(`${item_id_prefix}.${teams[result.selection]}`, 1);
		inventory.give(player, new_item);

		if (player.getGameMode() === "creative") return;

		inventory.consume(player, item);
	});
}};

export {
	open
};