const spawn_in_air = {onUse({itemStack: {typeId: entity_id}, source: player, source: {location}}) { // COMMENT: Requires that the item used and the entity spawned have the same identifier
	const view_direction = player.getViewDirection();

	const ray_hit = player.dimension.getEntitiesFromRay(
		player.getHeadLocation(),
		view_direction,
		{type: entity_id, maxDistance: 7}
	);
	if (ray_hit.length !== 0) return;

	const tutorial = player.dimension.getEntities({
		type       : "tms_mlb:tutorial",
		location   : location,
		maxDistance: 7
	});

	if (tutorial.length !== 0) {
		player.playSound("block.false_permissions", {
			pitch : 1,
			volume: 0.3
		});
		return;
	}

	const spawn_location = {
		x: location.x + view_direction.x * 2,
		y: location.y,
		z: location.z + view_direction.z * 2,
	};
	player.dimension.spawnEntity(entity_id, spawn_location);
}};

export {
	spawn_in_air
};